diff --git a/lib/resource-1.0/russian/PhraseRus.gf b/lib/resource-1.0/russian/PhraseRus.gf
index 6639dc3dc..073f3f881 100644
--- a/lib/resource-1.0/russian/PhraseRus.gf
+++ b/lib/resource-1.0/russian/PhraseRus.gf
@@ -1,25 +1,25 @@
 --# -path=.:../abstract:../common:../../prelude
 
 concrete PhraseRus of Phrase = CatRus ** open Prelude, ResRus in {
---
---  lin
---    PhrUtt pconj utt voc = {s = pconj.s ++ utt.s ++ voc.s} ;
---
---    UttS s = s ;
---    UttQS qs = {s = qs.s ! QDir} ;
---    UttImpSg pol imp = {s = pol.s ++ imp.s ! pol.p ! Sg} ;
---    UttImpPl pol imp = {s = pol.s ++ imp.s ! pol.p ! Pl} ;
---
---    UttIP ip = {s = ip.s ! Nom} ; --- Acc also
---    UttIAdv iadv = iadv ;
---    UttNP np = {s = np.s ! Acc} ;
---    UttVP vp = {s = infVP False vp (agrP3 Sg)} ;
---    UttAdv adv = adv ;
---
---    NoPConj = {s = []} ;
---    PConjConj conj = conj ;
---
---    NoVoc = {s = []} ;
---    VocNP np = {s = "," ++ np.s ! Nom} ;
---
+
+  lin
+    PhrUtt pconj utt voc = {s = pconj.s ++ utt.s ++ voc.s} ;
+
+    UttS s = s ;
+    UttQS qs = {s = qs.s ! QDir} ;
+    UttImpSg pol imp = {s = pol.s ++ imp.s ! pol.p ! Masc! Sg} ;
+    UttImpPl pol imp = {s = pol.s ++ imp.s ! pol.p ! Masc!Pl} ;
+
+    UttIP ip = {s = ip.s ! PF Nom No NonPoss} ; --- Acc also
+    UttIAdv iadv = iadv ;
+    UttNP np = {s = np.s ! PF Acc No NonPoss} ;
+    UttVP vp = {s = vp.s ! ClInfinit ! ASg Masc! P3} ;
+    UttAdv adv = adv ;
+
+    NoPConj = {s = []} ;
+    PConjConj conj = conj ;
+
+    NoVoc = {s = []} ;
+    VocNP np = {s = "," ++ np.s ! PF Nom No NonPoss} ;
+
 }
diff --git a/lib/resource-1.0/russian/QuestionRus.gf b/lib/resource-1.0/russian/QuestionRus.gf
index 90e44bf65..23c1aff13 100644
--- a/lib/resource-1.0/russian/QuestionRus.gf
+++ b/lib/resource-1.0/russian/QuestionRus.gf
@@ -1,61 +1,55 @@
 --# -path=.:../abstract:../common:../../prelude
 
 concrete QuestionRus of Question = CatRus ** open ResRus, Prelude in {
---
---  flags optimize=all_subs ;
---
---  lin
---
---    QuestCl cl = {
---      s = \\t,a,p => 
---            let cls = cl.s ! t ! a ! p 
---            in table {
---              QDir   => cls ! OQuest ;
---              QIndir => "if" ++ cls ! ODir
---              } ---- "whether" in ExtRus
---      } ;
---
---    QuestVP qp vp = 
---      let cl = mkClause (qp.s ! Nom) {n = qp.n ; p = P3} vp
---      in {s = \\t,a,b,_ => cl.s ! t ! a ! b ! ODir} ;
---
---    QuestSlash ip slash = 
---      mkQuestion (ss (slash.c2 ++ ip.s ! Acc)) slash ;
---      --- stranding in ExtRus 
---
---    QuestIAdv iadv cl = mkQuestion iadv cl ;
---
---    QuestIComp icomp np = 
---      mkQuestion icomp (mkClause (np.s ! Nom) np.a (predAux auxBe)) ;
---
---
---    PrepIP p ip = {s = p.s ++ ip.s ! Nom} ;
---
---    AdvIP ip adv = {
---      s = \\c => ip.s ! c ++ adv.s ;
---      n = ip.n
---      } ;
--- 
---    IDetCN idet num ord cn = {
---      s = \\c => idet.s ++ num.s ++ ord.s ++ cn.s ! idet.n ! c ; 
---      n = idet.n
---      } ;
---
---    CompIAdv a = a ;
---
---  oper
---    mkQuestion : 
---      {s : Str} -> Clause -> 
---      {s : Tense => Anteriority => Polarity => QForm => Str} = \wh,cl ->
---      {
---      s = \\t,a,p => 
---            let 
---              cls = cl.s ! t ! a ! p ;
---              why = wh.s
---            in table {
---              QDir   => why ++ cls ! OQuest ;
---              QIndir => why ++ cls ! ODir
---              }
---      } ;
---
+
+  flags optimize=all_subs ;
+
+  lin
+
+    QuestCl cl = {s = \\b,cf,_ => cl.s ! b ! cf  } ; 
+
+    QuestVP kto spit =
+    {s = \\b,clf,qf  => (predVerbPhrase kto spit).s!b!clf  } ;
+
+    QuestSlash Kto yaGovoruO =
+    let {  kom = Kto.s ! (mkPronForm yaGovoruO.c No NonPoss) ; o = yaGovoruO.s2 } in 
+    {s =  \\b,clf,_ => o ++ kom ++ yaGovoruO.s ! b ! clf  
+    } ;
+
+    QuestIAdv kak tuPozhivaesh =
+    {s = \\b,clf,q => kak.s ++ tuPozhivaesh.s!b!clf } ; 
+ 
+    QuestIComp kak tuPozhivaesh =
+    {s = \\b,clf,q => let ne = case b of {Neg => ""; Pos => []}
+     in 
+     kak.s ++ ne ++tuPozhivaesh.s! PF Nom No NonPoss } ; 
+
+
+    PrepIP p ip = {s = p.s ++ ip.s ! PF Nom No NonPoss} ;
+
+    AdvIP ip adv = {
+      s = \\c => ip.s ! c ++ adv.s ;
+       n = ip.n; p=ip.p; g=ip.g; anim=ip.anim; pron=ip.pron 
+      } ;
+ 
+    IDetCN kakoj pyat umeluj okhotnik =
+    {s = \\pf => case kakoj.c of {
+       Nom => 
+        kakoj.s ! AF (extCase pf) okhotnik.anim (gNum okhotnik.g kakoj.n) ++ 
+         pyat.s! (extCase pf) ! okhotnik.g ++ 
+         umeluj.s!AF (extCase pf) okhotnik.anim (gNum okhotnik.g kakoj.n)++
+         okhotnik.s ! kakoj.n ! (extCase pf) ; 
+       _ => 
+        kakoj.s ! AF (extCase pf) okhotnik.anim (gNum okhotnik.g kakoj.n) ++ 
+        pyat.s! (extCase pf) ! okhotnik.g ++ 
+        umeluj.s!AF (extCase pf) okhotnik.anim (gNum okhotnik.g kakoj.n)++  
+        okhotnik.s ! kakoj.n ! kakoj.c };
+     n = kakoj.n ; 
+     p = P3 ;
+     pron = False;
+     g = kakoj.g ;
+     anim = okhotnik.anim 
+    } ;
+
+    CompIAdv a = a ;
 }
diff --git a/lib/resource-1.0/russian/RelativeRus.gf b/lib/resource-1.0/russian/RelativeRus.gf
index f3afd557d..b3966de39 100644
--- a/lib/resource-1.0/russian/RelativeRus.gf
+++ b/lib/resource-1.0/russian/RelativeRus.gf
@@ -1,46 +1,36 @@
---# -path=.:../abstract:../common:../../prelude
-
-concrete RelativeRus of Relative = CatRus ** open ResRus in {
---
---  flags optimize=all_subs ;
---
---  lin
---
---    RelCl cl = {
---      s = \\t,a,p,_ => "such" ++ "that" ++ cl.s ! t ! a ! p ! ODir
---      } ;
---
---    RelVP rp vp = {
---      s = \\t,ant,b,ag => 
---        let 
---          agr = case rp.a of {
---            RNoAg => ag ;
---            RAg a => a
---            } ;
---          cl = mkClause (rp.s ! RC Nom) agr vp
---        in
---        cl.s ! t ! ant ! b ! ODir
---      } ;
---
----- Preposition stranding: "that we are looking at". Pied-piping is
----- deferred to $ExtRus.gf$ ("at which we are looking").
---
---    RelSlash rp slash = {
---      s = \\t,a,p,_ => rp.s ! RC Acc ++ slash.s ! t ! a ! p ! ODir ++ slash.c2
---      } ;
---
---    FunRP p np rp = {
---      s = \\c => np.s ! Acc ++ p.s ++ rp.s ! RPrep ;
---      a = RAg np.a
---      } ;
---
---    IdRP = {
---      s = table {
---        RC Gen => "whose" ; 
---        RC _   => "that" ;
---        RPrep  => "which"
---        } ;
---      a = RNoAg
---      } ;
---
-}
+--# -path=.:../abstract:../common:../../prelude
+
+concrete RelativeRus of Relative = CatRus ** open ResRus, MorphoRus in {
+
+  flags optimize=all_subs ; coding=utf8 ;
+
+  lin
+
+    RelCl A =   {s = \\b,clf,gn,c, anim => 
+     takoj.s ! AF c anim gn ++ "что" ++ A.s !b!clf};
+
+    RelVP kotoruj gulyaet =
+    { s = \\b,clf,gn, c, anim =>  let { nu = numGNum gn } in
+      kotoruj.s ! gn ! c ! anim ++ gulyaet.s2 ++ gulyaet.s ! clf ! gn !P3 ++ 
+       gulyaet.s3 ! genGNum gn ! nu
+    } ;
+
+
+-- Preposition stranding: "that we are looking at". Pied-piping is
+-- deferred to $ExtRus.gf$ ("at which we are looking").
+
+    RelSlash kotoruj yaVizhu =
+    {s = \\b,clf,gn, _ , anim => yaVizhu.s2 ++ kotoruj.s ! gn ! yaVizhu.c ! anim 
+         ++ yaVizhu.s!b!clf 
+    } ;
+
+    FunRP p mama kotoruj =
+    {s = \\gn,c, anim => let {nu = numGNum gn} in
+           mama.s ! PF c No NonPoss ++  
+           p.s ++ kotoruj.s !  gn ! p.c ! anim
+    } ;
+
+    IdRP ={ s  = \\gn, c, anim => 
+     kotorujDet.s ! (AF c anim gn )} ;
+}
+
